﻿/****** Object:  Table [dbo].[Places]    Script Date: 9/19/2022 4:28:31 PM ******/
--  Places ایجاد جدول  

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[Places](
  [ID] [int] IDENTITY(1,1) NOT NULL,
  [Name] [nvarchar](300) NOT NULL,
  [IsParent] [bit] NOT NULL,
  [ParentID] [int] NOT NULL,
  [OrderNumber] [int] NOT NULL,
  [ChildCount] [int] NOT NULL,
  [Description] [nvarchar](max) NULL,
 CONSTRAINT [PK_Places] PRIMARY KEY CLUSTERED 
(
  [ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[Places] ADD  CONSTRAINT [DF_PLACES_isCategoryContainer]  DEFAULT ((0)) FOR [IsParent]
GO

ALTER TABLE [dbo].[Places] ADD  CONSTRAINT [DF_places_ParentID]  DEFAULT ((0)) FOR [ParentID]
GO

ALTER TABLE [dbo].[Places] ADD  CONSTRAINT [DF_places_OrderNumber]  DEFAULT ((0)) FOR [OrderNumber]
GO

ALTER TABLE [dbo].[Places] ADD  CONSTRAINT [DF_placess_Count]  DEFAULT ((0)) FOR [ChildCount]

GO

IF ((SELECT value FROM dbo.Cache WHERE name='software_language')=N'فارسی')
BEGIN
SET IDENTITY_INSERT [dbo].[Places] ON 
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (1, N'آذربايجان شرقي', 1, 0, 0, 19, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (2, N'آذربايجان غربي', 1, 0, 0, 14, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (3, N'اردبيل', 1, 0, 0, 9, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (4, N'استان اصفهان', 1, 0, 0, 21, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (5, N'استان ايلام', 1, 0, 0, 7, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (6, N'استان بوشهر', 1, 0, 0, 9, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (7, N'استان تهران', 1, 0, 0, 13, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (8, N'چهارمحال و بختياري', 1, 0, 0, 6, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (9, N'خراسان جنوبي', 1, 0, 0, 7, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (10, N'خراسان رضوي', 1, 0, 0, 19, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (11, N'خراسان شمالي', 1, 0, 0, 6, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (12, N'خوزستان', 1, 0, 0, 20, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (13, N'استان زنجان', 1, 0, 0, 7, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (14, N'استان سمنان', 1, 0, 0, 5, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (15, N'سيستان و بلوچستان', 1, 0, 0, 11, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (16, N'فارس', 1, 0, 0, 24, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (17, N'استان قزوين', 1, 0, 0, 5, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (18, N'استان قم', 1, 0, 0, 1, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (19, N'کردستان', 1, 0, 0, 10, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (20, N'استان کرمان', 1, 0, 0, 16, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (21, N'استان کرمانشاه', 1, 0, 0, 14, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (22, N'کهگيلويه و بويراحمد', 1, 0, 0, 6, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (23, N'گلستان', 1, 0, 0, 12, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (24, N'گيلان', 1, 0, 0, 16, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (25, N'لرستان', 1, 0, 0, 9, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (27, N'مازندران', 1, 0, 0, 16, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (28, N'مرکزي', 1, 0, 0, 10, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (29, N'هرمزگان', 1, 0, 0, 11, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (30, N'استان همدان', 1, 0, 0, 8, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (31, N'استان يزد', 1, 0, 0, 10, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (32, N'آذرشهر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (33, N'اسکو', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (34, N'اهر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (35, N'بستان‌آباد', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (36, N'بناب', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (37, N'تبریز', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (38, N'جلفا', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (39, N'چاراویماق', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (40, N'سراب', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (41, N'شبستر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (42, N'عجب‌شیر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (43, N'کلیبر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (44, N'مراغه', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (45, N'مرند', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (46, N'ملکان', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (47, N'میانه', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (48, N'ورزقان', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (49, N'هریس', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (50, N'هشترود', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (51, N'ارومیه', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (52, N'اشنویه', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (53, N'بوکان', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (54, N'پیرانشهر', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (55, N'تکاب', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (56, N'چالدران', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (57, N'خوی', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (58, N'سردشت', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (59, N'سلماس', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (60, N'شاهین‌دژ', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (61, N'ماکو', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (62, N'مهاباد', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (63, N'میاندوآب', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (64, N'نقده', 0, 2, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (65, N'اردبیل', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (66, N'بیله‌سوار', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (67, N'پارس‌آباد', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (68, N'خلخال', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (69, N'کوثر', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (70, N'گِرمی', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (71, N'مِشگین‌شهر', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (72, N'نَمین', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (73, N'نیر', 0, 3, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (74, N'آران و بیدگل', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (75, N'اردستان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (76, N'اصفهان ', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (77, N'برخوار و میمه', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (78, N'تیران و کرون', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (79, N'چادگان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (80, N'خمینی‌شهر', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (81, N'خوانسار', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (82, N'سمیرم', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (83, N'شهرضا', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (84, N'سمیرم سفلی', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (85, N'فریدن', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (86, N'فریدون‌شهر', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (87, N'فلاورجان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (88, N'کاشان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (89, N'گلپایگان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (90, N'لنجان', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (91, N'مبارکه', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (92, N'نائین', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (93, N'نجف‌آباد', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (94, N'نطنز', 0, 4, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (95, N'آبدانان', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (96, N'ایلام', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (97, N'ایوان', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (98, N'دره‌شهر', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (99, N'دهلران', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (100, N'شیروان و چرداول', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (101, N'مهران', 0, 5, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (102, N'بوشهر', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (103, N'تنگستان ', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (104, N'جم', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (105, N'دشتستان', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (106, N'دشتی', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (107, N'دیر', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (108, N'دیلم', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (109, N'کنگان', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (110, N'گناوه', 0, 6, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (111, N'اسلام‌شهر', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (112, N'پاکدشت', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (113, N'تهران', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (114, N'دماوند', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (115, N'رباط‌کریم', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (116, N'ری', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (117, N'ساوجبلاغ', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (118, N'شمیرانات', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (119, N'شهریار', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (120, N'فیروزکوه', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (121, N'کرج', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (122, N'نظرآباد', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (123, N'ورامین', 0, 7, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (124, N'اردل', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (125, N'بروجن', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (126, N'شهرکرد', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (127, N'فارسان', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (128, N'کوهرنگ', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (129, N'لردگان', 0, 8, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (130, N'بیرجند', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (131, N'درمیان', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (132, N'سرایان', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (133, N'سربیشه', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (134, N'فردوس', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (135, N'قائنات', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (136, N'نهبندان', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (137, N'بردسکن', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (138, N'تایباد', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (139, N'تربت جام', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (140, N'تربت حیدریه', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (141, N'چناران', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (142, N'خلیل‌آباد', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (143, N'خواف', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (144, N'درگز', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (145, N'رشتخوار', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (146, N'سبزوار ', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (147, N'سرخس', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (148, N'فریمان', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (149, N'قوچان', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (150, N'کاشمر', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (151, N'کلات', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (152, N'گناباد', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (153, N'مشهد', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (154, N'مه ولات', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (155, N'نیشابور', 0, 10, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (156, N'اسفراین', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (157, N'بجنورد', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (158, N'جاجرم', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (159, N'شیروان', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (160, N'فاروج', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (161, N'مانه و سملقان', 0, 11, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (162, N'آبادان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (163, N'امیدیه', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (164, N'اندیمشک', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (165, N'اهواز', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (166, N'ایذه', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (167, N'باغ‌ملک', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (168, N'بندر ماهشهر', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (169, N'بهبهان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (170, N'خرمشهر', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (171, N'دزفول', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (172, N'دشت آزادگان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (173, N'رامشیر', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (174, N'رامهرمز', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (175, N'شادگان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (176, N'شوش', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (177, N'شوشتر', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (178, N'گتوند', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (179, N'لالی', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (180, N'مسجد سلیمان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (181, N'هندیجان', 0, 12, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (182, N'ابهر', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (183, N'ایجرود', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (184, N'خدابنده', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (185, N'خرمدره', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (186, N'زنجان', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (187, N'طارم', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (188, N'ماه‌نشان', 0, 13, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (189, N'دامغان', 0, 14, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (190, N'سمنان', 0, 14, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (191, N'شاهرود', 0, 14, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (192, N'گرمسار', 0, 14, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (193, N'مهدی‌شهر', 0, 14, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (194, N'ایرانشهر', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (195, N'چابهار', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (196, N'خاش', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (197, N'دلگان', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (198, N'زابل', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (199, N'زاهدان', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (200, N'زهک', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (201, N'سراوان', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (202, N'سرباز', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (203, N'کنارک', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (204, N'نیک‌شهر', 0, 15, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (205, N'آباده', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (206, N'ارسنجان', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (207, N'استهبان', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (208, N'اقلید', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (209, N'بوانات', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (210, N'پاسارگاد', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (211, N'جهرم', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (212, N'خرم‌بید', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (213, N'خنج', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (214, N'داراب', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (215, N'زرین‌دشت', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (216, N'سپیدان', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (217, N'شیراز', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (218, N'فراشبند', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (219, N'فسا', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (220, N'فیروزآباد', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (221, N'قیر و کارزین', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (222, N'کازرون', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (223, N'لارستان', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (224, N'لامِرد', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (225, N'مرودشت ', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (226, N'ممسنی', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (227, N'مهر', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (228, N'نی‌ریز', 0, 16, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (229, N'آبیک', 0, 17, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (230, N'البرز', 0, 17, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (231, N'بوئین‌زهرا', 0, 17, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (232, N'تاکستان', 0, 17, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (233, N'قزوین', 0, 17, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (234, N'قم', 0, 18, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (235, N'بانه', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (236, N'بیجار', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (237, N'دیواندره', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (238, N'سروآباد', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (239, N'سقز', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (240, N'سنندج', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (241, N'قروه', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (242, N'کامیاران', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (243, N'مریوان', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (244, N'دهگلان', 0, 19, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (245, N'بافت', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (246, N'بردسیر', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (247, N'بم', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (248, N'جیرفت', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (249, N'راور', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (250, N'رفسنجان', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (251, N'رودبار جنوب', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (252, N'زرند', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (253, N'سیرجان', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (254, N'شهر بابک', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (255, N'عنبرآباد', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (256, N'قلعه گنج', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (257, N'کرمان', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (258, N'کوهبنان', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (259, N'کهنوج', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (260, N'منوجان', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (261, N'اسلام‌آباد غرب', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (262, N'پاوه', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (263, N'ثلاث باباجانی', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (264, N'جوانرود', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (265, N'دالاهو', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (266, N'روانسر', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (267, N'سرپل ذهاب', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (268, N'سنقر', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (269, N'صحنه', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (270, N'قصر شیرین', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (271, N'کرمانشاه', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (272, N'کنگاور', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (273, N'گیلان غرب', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (274, N'هرسین', 0, 21, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (275, N'بویراحمد', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (276, N'بهمئی', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (277, N'دنا', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (278, N'کهگیلویه', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (279, N'گچساران', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (280, N'یاسوج', 0, 22, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (281, N'آزادشهر', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (282, N'آق‌قلا', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (283, N'بندر گز', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (284, N'ترکمن', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (285, N'رامیان', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (286, N'علی‌آباد', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (287, N'کردکوی', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (288, N'کلاله', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (289, N'گرگان', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (290, N'گنبد کاووس', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (291, N'مراوه‌تپه', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (292, N'مینودشت', 0, 23, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (293, N'آستارا', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (294, N'آستانه اشرفیه', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (295, N'اَملَش', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (296, N'بندر انزلی', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (297, N'رشت', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (298, N'رضوانشهر', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (299, N'رودبار', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (300, N'رودسر', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (301, N'سیاهکل', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (302, N'شَفت', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (303, N'صومعه‌سرا', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (304, N'طوالش', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (305, N'فومَن', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (306, N'لاهیجان ', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (307, N'لنگرود', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (308, N'ماسال', 0, 24, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (309, N'ازنا', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (310, N'اليگودرز', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (311, N'بروجرد', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (312, N'پل‌دختر', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (313, N'خرم‌آباد ', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (314, N'دورود', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (315, N'دلفان ', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (316, N'سلسله', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (317, N'کوهدشت', 0, 25, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (318, N'آمل', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (319, N'بابل', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (320, N'بابلسر', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (321, N'بهشهر', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (322, N'تنکابن', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (323, N'جويبار', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (324, N'چالوس', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (325, N'رامسر', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (326, N'ساري', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (327, N'سوادکوه', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (328, N'قائم‌شهر', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (329, N'گلوگاه', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (330, N'محمودآباد', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (331, N'نکا', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (332, N'نور', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (333, N'نوشهر', 0, 27, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (334, N'آشتيان', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (335, N'اراک', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (336, N'تفرش', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (337, N'خمين', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (338, N'دليجان', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (339, N'زرنديه', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (340, N'ساوه', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (341, N'شازند', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (342, N'کميجان', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (343, N'محلات', 0, 28, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (344, N'ابوموسي', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (345, N'بستک', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (346, N'بندر عباس', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (347, N'بندر لنگه', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (348, N'جاسک', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (349, N'حاجي‌آباد', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (350, N'خمير', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (351, N'رودان', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (352, N'قشم', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (353, N'گاوبندي', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (354, N'ميناب', 0, 29, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (355, N'اسدآباد', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (356, N'بهار', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (357, N'تويسرکان', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (358, N'رزن', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (359, N'کبودرآهنگ', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (360, N'ملاير', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (361, N'نهاوند', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (362, N'همدان', 0, 30, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (363, N'ابرکوه', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (364, N'اردکان', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (365, N'بافق', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (366, N'تفت', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (367, N'خاتم', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (368, N'صدوق', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (369, N'طبس', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (370, N'مهريز', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (371, N'مِيبُد', 0, 31, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (372, N'يزد', 0, 31, 0, 0, NULL)
SET IDENTITY_INSERT [dbo].[Places] OFF
END
ELSE 
BEGIN

SET IDENTITY_INSERT [dbo].[Places] ON 
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (1, N'پارێزگای هەولێر', 1, 0, 0, 7, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (2, N'هەولێر', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (3, N'شەقڵاوە', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (4, N'سۆران', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (5, N'چۆمان', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (6, N'کۆیە', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (7, N'مێرگە سور', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (8, N'حاج ئۆمەران', 0, 1, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (9, N'پارێزگای سڵێمانی', 1, 0, 0, 10, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (10, N'سڵێمانی', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (11, N'ڕانیە', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (12, N'چوارقرنە', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (13, N'حاجی ئاوا', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (14, N'سەنگەسەر', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (15, N'ژاراوە', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (16, N'قەڵادزێ', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (17, N'شکارتە', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (18, N'دوکان', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (19, N'چەمچەماڵ', 0, 9, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (20, N'پارێزگای دهۆک', 1, 0, 0, 4, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (22, N'دهۆک', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (23, N'زاخۆ', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (24, N'ئاکرێ', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (25, N'ئامێدی', 0, 20, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (26, N'پارێزگای هەڵەبجە', 1, 0, 0, 2, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (27, N'هەڵەبجە', 0, 26, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (28, N'دەربەندیخان', 0, 26, 0, 0, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (29, N'وڵاتانی تر', 1, 0, 0, 1, NULL)
INSERT [dbo].[Places] ([ID], [Name], [IsParent], [ParentID], [OrderNumber], [ChildCount], [Description]) VALUES (30, N'چین', 0, 29, 0, 0, NULL)
SET IDENTITY_INSERT [dbo].[Places] OFF

END

GO

-- Customers تغییرات مربوط به جدول 

ALTER TABLE dbo.Customers ADD PlacesRef INT
GO
ALTER TABLE dbo.Customers ADD CONSTRAINT FK_Customers_PlacesRef FOREIGN KEY (PlacesRef) REFERENCES Places(ID)

GO

UPDATE dbo.Customers SET PlacesRef=(select ID from dbo.Places where Name=dbo.Customers.TownShip)
GO
UPDATE dbo.Cache SET value=(select ID from dbo.Places where Name=(select value from Cache where name='company_ProvinceName'))
where name='company_Province'
GO
UPDATE dbo.Cache SET value=(select ID from dbo.Places where Name=(select value from Cache where name='company_TaxOfficeName'))
where name='company_TaxOffice'
GO
UPDATE dbo.Cache SET value=(select ID from dbo.Places where Name=(select value from Cache where name='company_TownName'))
where name='company_Town'

GO

-- Products تغییرات مربوط به جدول 



EXEC sp_rename 'dbo.Products.CurrencyRef', 'SellCurrencyRef', 'COLUMN'
GO
ALTER TABLE dbo.Products ADD BuyCurrencyRef INT NULL
GO
ALTER TABLE dbo.Products ADD CONSTRAINT FK_Products_BuyCurrencyRef FOREIGN KEY (BuyCurrencyRef) REFERENCES Currencies(ID)
GO
UPDATE dbo.[Products] 
SET BuyCurrencyRef = (SELECT CurrencyRef FROM ProductCardex WHERE Products.LastIDCardexInc = ProductCardex.ID)
WHERE dbo.[Products].LastIDCardexInc IS NOT NULL AND dbo.[Products].LastIDCardexInc <> 0 
AND (SELECT CurrencyRef FROM ProductCardex WHERE Products.LastIDCardexInc = ProductCardex.ID) is NOT NULL
GO
UPDATE dbo.[Products] 
SET BuyCurrencyRef = (SELECT value FROM dbo.Cache WHERE name='CurrencyDefualtID')
WHERE dbo.[Products].BuyCurrencyRef IS NULL
GO
UPDATE dbo.[Products] 
SET BuyCurrencyRef = SellCurrencyRef
WHERE dbo.[Products].BuyCurrencyRef IS NULL
GO
UPDATE dbo.[Products] 
SET BuyCurrencyRef = (SELECT TOP(1)ID FROM Currencies)
WHERE dbo.[Products].BuyCurrencyRef IS NULL
GO
ALTER TABLE dbo.Products ALTER COLUMN BuyCurrencyRef INT NOT NULL
GO
ALTER TABLE dbo.Products ADD SaleInApp bit NULL CONSTRAINT [DF_Products_SaleInApp]  DEFAULT ((1))
GO
UPDATE dbo.Products SET SaleInApp=1
GO
ALTER TABLE dbo.Products ALTER COLUMN SaleInApp bit NOT NULL

GO


-- Cashs تغییرات مربوط به جدول 

ALTER TABLE dbo.Cashs ADD VisitorRef INT NULL
GO
ALTER TABLE dbo.Cashs ADD CONSTRAINT FK_Cashs_VisitorRef FOREIGN KEY (VisitorRef) REFERENCES Customers(ID)
GO
ALTER TABLE dbo.Cashs ADD Recived bit NULL

GO

UPDATE [dbo].[Cache]   SET [value] = '2.0.86'  Where name='VersionDatabase'
